#DELMACHE Benjamin / TANGENT'DELTA / CREATION : 05/05/2014 / MODIF : 21/05/14
#Macro permettant le calcul des FRF

def dyna_visco_frf(self,MATER_ELAS_FO,FREQ,LIST_FREQ,__asseKgr,modes,__asseMg,__asseKg,__num,__lfor,__listKv,__lKv,list_FREQ,e0,eta0,**args):

        from Accas import _F
        from Utilitai.Utmess     import UTMESS
        from math import exp
        import aster
        from numpy import array

        DEFI_BASE_MODALE = self.get_cmd('DEFI_BASE_MODALE')
        PROJ_MATR_BASE = self.get_cmd('PROJ_MATR_BASE')
        MODE_STATIQUE = self.get_cmd('MODE_STATIQUE')
        NUME_DDL = self.get_cmd('NUME_DDL')
        NUME_DDL_GENE = self.get_cmd('NUME_DDL_GENE')
        CALC_VECT_ELEM  =self.get_cmd('CALC_VECT_ELEM')
        ASSE_VECTEUR    =self.get_cmd('ASSE_VECTEUR')
        PROJ_MATR_BASE = self.get_cmd('PROJ_MATR_BASE')
        PROJ_VECT_BASE = self.get_cmd('PROJ_VECT_BASE')
        DYNA_LINE_HARM = self.get_cmd('DYNA_LINE_HARM')
        REST_GENE_PHYS = self.get_cmd('REST_GENE_PHYS')
        COMB_MATR_ASSE  =self.get_cmd('COMB_MATR_ASSE')
        CREA_CHAMP = self.get_cmd('CREA_CHAMP')
        CREA_RESU = self.get_cmd('CREA_RESU')
        DETRUIRE = self.get_cmd('DETRUIRE')


        self.DeclareOut('frf',self.sd)

        # Recuperation des donnes des mots clefs lors du calcul harmonique
        if args.has_key('CHARGE'):        CHARGE      = args['CHARGE']
        if args.has_key('NOM_CHAM'):        NOM_CHAM      = args['NOM_CHAM']


        # recuperation des caracteristiques de l'excitation
        no_force = aster.getcolljev(CHARGE.nom.ljust(8)+'.CHME.LIGRE.NEMA') # numeros des noeuds avec une force nodale imposee
        print 'noeuds avec force_nodale : ', no_force

        iret,ibid,nom_mail = aster.dismoi('NOM_MAILLA',__num.nom,'NUME_DDL','F')
        #maillage = sd_maillage(nom_mail)
        gr_no_mail = aster.getcolljev(nom_mail.ljust(8)+'.GROUPENO       ') # nom des groupes de noeuds presents dans le maillage
        print 'groupes noeuds dans maillage : ', gr_no_mail

        ddl = aster.getvectjev(CHARGE.nom.ljust(8)+'.CHME.FORNO.VALE        ')
        print 'ddl : ', ddl
        # ind = array(ddl).nonzero()[0]    # liste des indices des DDL affectes par une force nodale
        direction = array( [tuple(array(ddl[i*12:(i+1)*12]).nonzero()[0]) for i in range(0, len(ddl)/12)] )
           # tableau contenant, pour chaque noeud avec une force imposee, la liste des directions imposees
           # (/ 12 car chaque noeud porte 12 DDL)
        # direction = ind % 12    # liste dont les termes valent 0 si FX imposee, 1 si FY, et 2 si FZ
        #                         #                              3 si MX imposee, 4 si MY, et 5 si MZ
        #                         # (% 12 car chaque noeud porte 12 DDL)
        ddl_phys = [None]*len(no_force)
        for i in range(0, len(no_force)):
            ddl_phys[i]=[]
            for j in range(0,len(direction[i])):
                if direction[i][j]==0:
                    ddl_phys[i].append('DX')
                elif direction[i][j]==1:
                    ddl_phys[i].append('DY')
                elif direction[i][j]==2:
                    ddl_phys[i].append('DZ')
                if direction[i][j]==3:
                    ddl_phys[i].append('DRX')
                elif direction[i][j]==4:
                    ddl_phys[i].append('DRY')
                elif direction[i][j]==5:
                    ddl_phys[i].append('DRZ')
        
        # print "conclusion : "
        # for i in range(0, len(no_force)):
        #     print no_force[i+1][0], "est un noeud avec force nodale imposee en ", ddl_phys[i]
        
        
        no_mail = aster.getvectjev('MAIL    .NOMNOE                 ') # nom des noeuds presents dans le maillage
        # print 'noeuds dans le maillage : ', no_mail
        # print 'no_mail : ', type(no_mail)
        
        # finalement:
        mc_force_nodale=[]
        for i in range(1, len(no_force)+1):
            c=0
            mc_composante={}
            mc_composante['AVEC_CMP'] = tuple( ddl_phys[i-1] )
            for j in range(0, len(gr_no_mail)):
                c = gr_no_mail[gr_no_mail.keys()[j]].count(no_force[i][0])
                if c > 0:
                    print 'toto1 : ', gr_no_mail.keys()[j].strip()
                    mc_force_nodale.append( _F(GROUP_NO=gr_no_mail.keys()[j].strip(),
                                               **mc_composante)
                                           )
                    break
            if c==0:
                print 'toto2 : ', (no_mail[(no_force[i][0]-1)].strip())
                mc_force_nodale.append( _F(NOEUD=(no_mail[(no_force[i][0]-1)].strip()),
                                           **mc_composante)
                                       )
        
        print 'force nodale : ', mc_force_nodale
        
        __modstat=MODE_STATIQUE(MATR_RIGI=__asseKgr,
                                FORCE_NODALE=mc_force_nodale);

# PROJECTION DES MATRICES K ET M SUR UNE BASE FORMEE DES MODES REELS ET DES MODES STATIQUES



        __modrs=DEFI_BASE_MODALE(DIAG_MASS=_F(MODE_MECA=modes,
                                             MODE_STAT=__modstat,),);


        DETRUIRE(CONCEPT = _F (NOM = __modstat,) , )
        DETRUIRE(CONCEPT = _F (NOM = __asseKgr,) , )


        __ddlplein=NUME_DDL_GENE(BASE=__modrs,
                                STOCKAGE='PLEIN',);

        __Mgproj=PROJ_MATR_BASE(BASE=__modrs,
                               NUME_DDL_GENE=__ddlplein,
                               MATR_ASSE=__asseMg,);

        __Kgproj=PROJ_MATR_BASE(BASE=__modrs,
                               NUME_DDL_GENE=__ddlplein,
                               MATR_ASSE=__asseKg,);


# ASSEMBLAGE ET PROJECTION DES VECTEURS EXCITATION

        nf=0


        __felem=CALC_VECT_ELEM(OPTION='CHAR_MECA',
                                CHARGE=CHARGE,)

        __assef=ASSE_VECTEUR(VECT_ELEM=__felem,
                              NUME_DDL=__num,)

        __lfor[nf]=PROJ_VECT_BASE(BASE=__modrs,
                                  NUME_DDL_GENE=__ddlplein,
                                  VECT_ASSE=__assef,);

        nf=nf+1

        DETRUIRE(CONCEPT = _F (NOM = __felem,) , )
        DETRUIRE(CONCEPT = _F (NOM = __assef,) , )
        DETRUIRE(CONCEPT = _F (NOM = __asseMg,) , )
        DETRUIRE(CONCEPT = _F (NOM = __asseKg,) , )

# PROJECTION DE LA MATRICE DE RAIDEUR ISOLEE POUR CHAQUE PARTIE VISCOELASTIQUE

        ny=0
        for y in MATER_ELAS_FO:
            __lKv[ny]=PROJ_MATR_BASE(BASE=__modrs,
                                   NUME_DDL_GENE=__ddlplein,
                                   MATR_ASSE=__listKv[ny],);
            ny=ny+1

        self.DeclareOut('frf',self.sd)

# CALCUL DE LA REPONSE DU SYSTEME PROJETE POUR F=FMIN
        __dyngene=DYNA_LINE_HARM(MATR_MASS=__Mgproj,
                                MATR_RIGI=__Kgproj,
                                FREQ=list_FREQ[0],
                                EXCIT=_F(VECT_ASSE_GENE=__lfor[0],
                                         COEF_MULT=1,),),



#**motsclexcit)

        frf=REST_GENE_PHYS(RESU_GENE=__dyngene,
                              MODE_MECA=__modrs,
                              NOM_CHAM=NOM_CHAM,);


      # CALCUL DE LA REPONSE DU SYSTEME PROJETE POUR F>FMIN

        for num_freq in range(1,len(list_FREQ)):

            __Kwproj=__Kgproj
            ny=0
            for y in MATER_ELAS_FO:
                e=y['E'](list_FREQ[num_freq])
                eta=y['AMOR_HYST'](list_FREQ[num_freq])

                __Kwproj=COMB_MATR_ASSE(COMB_C=(_F(MATR_ASSE=__Kwproj,
                                                  COEF_R=1.),
                                               _F(MATR_ASSE=__lKv[ny],
                                                  COEF_C=('RI',e/e0[ny]-1,eta*e/e0[ny]-eta0[ny],),),),)

                ny=ny+1

            __dyngene=DYNA_LINE_HARM(MATR_MASS=__Mgproj,
                                    MATR_RIGI=__Kwproj,
                                    FREQ=list_FREQ[num_freq],
                                    EXCIT=_F(VECT_ASSE_GENE=__lfor[0],
                                             COEF_MULT=1,),),


            __dynphys=REST_GENE_PHYS(RESU_GENE=__dyngene,
                                    MODE_MECA=__modrs,
                                    TOUT_CHAM='OUI',);


            __resveu=CREA_CHAMP(OPERATION='EXTR',
                               NOM_CHAM=NOM_CHAM,
                               TYPE_CHAM='NOEU_DEPL_C',
                               RESULTAT=__dynphys,
                               NUME_ORDRE=1,);

            frf=CREA_RESU(reuse=frf,
                             OPERATION='AFFE',
                             TYPE_RESU='DYNA_HARMO',
                             NOM_CHAM=NOM_CHAM,
                             AFFE=_F(CHAM_GD=__resveu,
                                     FREQ=list_FREQ[num_freq],),);

        return frf


