SetFactory("OpenCASCADE");

lcm = 0.25;

l = 5.0;
h = 3.681;

Point(1) = {-l, -l, 0, lcm};
Point(2) = {l, -l, 0, lcm};
Point(3) = {l, l, 0, lcm};
Point(4) = {-l, l , 0, lcm};
Point(5) = {0, -h, 0, lcm};
Point(6) = {h, 0, 0, lcm};
Point(7) = {0, h, 0, lcm};
Point(8) = {-h, 0, 0, lcm};
Spline(1) = {1, 5, 2};
Spline(2) = {2, 6, 3};
Spline(3) = {3, 7, 4};
Spline(4) = {4, 8, 1};
Line Loop(1) = {1, 2, 3, 4};
Surface(1) = {1};
Physical Line("cables", 200) = {1, 2, 3, 4};
Physical Surface("membrane", 300) = {1};

Physical Point("pins", 100) = {9, 10, 11, 12};

Mesh 2;

Mesh.Format = 1;
Save "membrana.msh";
Mesh.Format = 33;
Save "membrana.med";
